unit hiScrollBarManager;

interface
     
uses Messages,Windows,Kol,Share,Debug,Win;

const
   Horz = SB_HORZ;
   Vert = SB_VERT;
   Both = SB_BOTH;
 
type
  THIScrollBarManager = class(TDebug)
   private
     fControl: PControl;
     si: TScrollInfo;
   public
     _prop_ControlManager:IControlManager;
     _prop_Bar: byte;
     _prop_ReDraw: boolean;
     _data_Data:THI_Event;
     _event_onSetPos:THI_Event;
     _event_onScrollMessage:THI_Event;
     
     function MessageScroll(var Msg: TMsg; var Rslt: Integer):boolean;
     procedure _work_doSetPos(var _Data:TData; Index:word);
     procedure _work_doShow(var _Data:TData; Index:word);
     procedure _work_doGetMessage(var _Data:TData; Index:word);
     procedure _var_GetPos(var _Data:TData; Index:word);
     procedure _var_GetMin(var _Data:TData; Index:word);
     procedure _var_GetMax(var _Data:TData; Index:word);
  end;

implementation
function THIScrollBarManager.MessageScroll;
var s: PData;
    dt,dp:TData;
    ind: integer;
begin
    Result := false;
    case Msg.message of
     WM_HSCROLL, WM_VSCROLL:
       begin
        si.fMask := SIF_POS;
        ind := Msg.message - 276;
        //Msg.message - 276 = 0 (SB_HORZ)   1 (SB_VERT)
        //  Msg.message = WM_HSCROLL = 276  WM_VSCROLL = 277
        GetScrollInfo(fControl.GetWindowHandle, ind, si);
        dtNull(dt);
        dtNull(dp);
        dtInteger(dt, ind);
        dtInteger(dp, si.nPos);
        AddMTData(@dt,@dp,s);
        _hi_OnEvent(_event_onScrollMessage, dt);
        FreeData(@dp);
        FreeData(@dt);
       end;
    end;
end;

procedure THIScrollBarManager._work_doGetMessage;
begin
    if not Assigned(_prop_ControlManager) then exit;
    fControl := _prop_ControlManager.ctrlpoint;
    si.cbSize := sizeof(si);
    fControl.OnMessage := MessageScroll;
end;

procedure THIScrollBarManager._work_doSetPos;
var sControl: PControl;
    SBCode, pos, oldpos: integer;
    val: TData; 
begin
    if not Assigned(_prop_ControlManager) then exit;
    sControl := _prop_ControlManager.ctrlpoint;
    val := ReadMTData(_Data, _data_Data);
    pos := 0;
    case ToString(val)[1] of
      '}':  SBCode := SB_LINERIGHT;
      '{':  SBCode := SB_LINELEFT;
      '<': SBCode := SB_PAGELEFT;
      '>': SBCode := SB_PAGERIGHT;
      else
       begin
        pos := ToInteger(val);
        SBCode := SB_THUMBTRACK;
       end;
    end; 
    oldpos := SetScrollPos(sControl.GetWindowHandle, _prop_Bar, pos, _prop_ReDraw);
    SendMessage(sControl.GetWindowHandle, WM_HSCROLL + _prop_Bar, pos shl 16 + SBCode, 0);
    _hi_OnEvent(_event_onSetPos, oldpos);
end;
{
procedure THIScrollBarManager._work_doSetRange;
var sControl: PControl;
    min, max: integer;
begin
    if not Assigned(_prop_ControlManager) then exit;
    sControl := _prop_ControlManager.ctrlpoint;
    min := ReadInteger(_Data, _data_Data1);
    max := ReadInteger(_Data, _data_Data2);
    SetScrollRange(sControl.GetWindowHandle, _prop_Bar, min, max, _prop_ReDraw);
    //SendMessage(sControl.GetWindowHandle, WM_HSCROLL + _prop_Bar, (pos shl 16 + SB_THUMBTRACK), 0);
    //_hi_OnEvent(_event_onSetRange);
end;
}
procedure THIScrollBarManager._work_doShow;
var sControl: PControl;
begin
    if not Assigned(_prop_ControlManager) then exit;
    sControl := _prop_ControlManager.ctrlpoint;
    ShowScrollBar(sControl.GetWindowHandle, _prop_Bar, ReadBool(_Data));
end;
{
procedure THIScrollBarManager._work_doEnable;
var sControl: PControl;
begin
    if not Assigned(_prop_ControlManager) then exit;
    sControl := _prop_ControlManager.ctrlpoint;
    EnableScrollBar(sControl.GetWindowHandle, _prop_Bar, ESB_DISABLE_BOTH);
end;
}
procedure THIScrollBarManager._var_GetPos;
var sControl: PControl;
begin
    if not Assigned(_prop_ControlManager) then exit;
    sControl := _prop_ControlManager.ctrlpoint;
    dtInteger(_Data, GetScrollPos(sControl.GetWindowHandle, _prop_Bar));
end;

procedure THIScrollBarManager._var_GetMin;
var sControl: PControl;
    min, max: integer;
begin
    if not Assigned(_prop_ControlManager) then exit;
    sControl := _prop_ControlManager.ctrlpoint;
    GetScrollRange(sControl.GetWindowHandle, _prop_Bar, min, max);
    dtInteger(_Data, min);
end;

procedure THIScrollBarManager._var_GetMax;
var sControl: PControl;
    min, max: integer;
begin
    if not Assigned(_prop_ControlManager) then exit;
    sControl := _prop_ControlManager.ctrlpoint;
    GetScrollRange(sControl.GetWindowHandle, _prop_Bar, min, max);
    dtInteger(_Data, max);
end;

end.